package cn.edu.zjvtit.cloudstorage.apiservice;

import cn.edu.zjvtit.cloudstorage.apiservice.store.DataServerStore;
import com.backblaze.erasure.ReedSolomon;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.context.annotation.Bean;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;



@SpringBootApplication
@EnableJpaRepositories
public class ApiServiceApplication extends SpringBootServletInitializer {

    private static final Logger logger = LoggerFactory.getLogger(ApiServiceApplication.class);

    public static void main(String[] args) {
        ReedSolomon codec = ReedSolomon.create(4,2);
        byte[][] shards = new byte[6][];
        shards[0] = new byte[]{0, 1};
        shards[1] = new byte[]{4, 5};
        shards[2] = new byte[2]; //2,3
        shards[3] = new byte[2]; //6,7
        shards[4] = new byte[]{44,45};
        shards[5] = new byte[]{40,41};
        boolean[] shardPresent = new boolean[]{true,true,false,false,true,true};
        codec.decodeMissing(shards,shardPresent,0,2);
        for(byte[] shard:shards){
            System.out.println(shard[0]);
            System.out.println(shard[1]);
        }

    }

    @Bean
    public RestTemplate restTemplate() {     //在SpringBoot启动类中注册RestTemplate
        return new RestTemplate();
    }

    @Bean
    public Logger getLogger() {
        return logger;
    }
}
