package cn.edu.zjvtit.cloudstorage.apiservice.repository;

import cn.edu.zjvtit.cloudstorage.apiservice.entity.ObjectEntity;
import org.springframework.context.annotation.Bean;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ObjectRepository extends JpaRepository<ObjectEntity, Integer> {
    public ObjectEntity findById(int id);

    ObjectEntity findByName(String name);

    ObjectEntity findFirstByNameOrderByVersionDesc(String name);

    ObjectEntity findByVersionAndName(int version, String name);

    Page<ObjectEntity> findAllByNameOrderByVersionDesc(String name, Pageable pageable);
    Page<ObjectEntity> findAll(Pageable pageable);

}
