package cn.edu.zjvtit.cloudstorage.dataservice.result;


import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.util.Map;

public class Result {
    private String message;
    private String code;

    private Map<String, Object> data;
    public Result(String msg, String code) {
        this.message = msg;
        this.code = code;
    }
    public Result withData(Map<String, Object> data) {
        this.data = data;
        return this;
    }
    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }
    public void setData(Map data) {
        this.data = data;
    }
    public Map<String,Object> getData() {
        return this.data;
    }
    public String toString(){
        ObjectMapper mapper = new ObjectMapper();
        try {
            return mapper.writeValueAsString(this);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
    }
}


